created new generic Linux container
diff --git a/buildbot/google/docker/buildbot-ubuntu-clang/Dockerfile b/buildbot/google/docker/buildbot-ubuntu-clang/Dockerfile
new file mode 100644
index 0000000..549a8ea
--- /dev/null
+++ b/buildbot/google/docker/buildbot-ubuntu-clang/Dockerfile
@@ -0,0 +1,75 @@
+#===-- Dockerfile --------------------------------------------------------===//
+# Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
+# See https://llvm.org/LICENSE.txt for license information.
+# SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
+#
+#===----------------------------------------------------------------------===//
+# Docker image used for the mlir-nvidia builder
+# 
+# Environment variables configurable at runtime:
+#    BUILDBOT_PORT - server port to connect to
+#===----------------------------------------------------------------------===//
+
+# Use the image from NVIDIA as base
+FROM ubuntu:18.04
+
+
+# install build tools
+RUN apt-get update; \
+    apt-get install -y software-properties-common apt-transport-https ca-certificates \
+    ninja-build git wget gnupg ccache \
+    python3 python3-pip python3-psutil
+
+# install latest clang release
+RUN bash -c "$(wget -O - https://apt.llvm.org/llvm.sh)"
+
+# configure default versions
+RUN update-alternatives --install /usr/bin/clang clang /usr/bin/clang-11 100 ;\
+    update-alternatives --install /usr/bin/clang++ clang++ /usr/bin/clang++-11 100 ;\
+    update-alternatives --install /usr/bin/lld lld /usr/bin/lld-11 100
+
+# Ubuntu ships with old cmake version, install the latest one
+# from https://apt.kitware.com/
+RUN wget -O - https://apt.kitware.com/keys/kitware-archive-latest.asc 2>/dev/null | \
+    gpg --dearmor - | \
+    tee /etc/apt/trusted.gpg.d/kitware.gpg >/dev/null ;\
+    apt-add-repository 'deb https://apt.kitware.com/ubuntu/ bionic main' ;\
+    apt-get update ;\
+    apt-get install -y cmake
+
+# install build bot version (server was at 2.8.5-dev)
+RUN pip3 install buildbot-worker==2.8.4
+
+# Workaround permissions issues when writing to named volumes
+# https://github.com/docker/compose/issues/3270#issuecomment-206214034 
+RUN mkdir -p /vol/test /vol/ccache /vol/worker ; \
+    chmod -R 777 /vol
+
+# Volume to mount secrets into the container
+VOLUME /vol/secrets
+# Volume to store data for local, manual of testing the container
+VOLUME /vol//test
+# Volume to store ccache
+VOLUME /vol/ccache
+# Volume for worker working directory (root of the buildbot files) 
+VOLUME /vol/worker
+
+# create user account, some test fail if run as root
+RUN useradd buildbot --create-home
+WORKDIR /vol/worker
+
+# copy startup script
+COPY run.sh /home/buildbot/
+RUN chmod a+rx /home/buildbot/run.sh
+
+USER buildbot
+ENV WORKER_NAME="ubuntu-clang"
+
+# Allow the server port of this agent to be configurable during deployment.
+# This way we can connect the same image to production and integration. 
+# Ports:
+#   9990 - production
+#   9994 - integration
+ENV BUILDBOT_PORT="9994"
+
+CMD /home/buildbot/run.sh
diff --git a/buildbot/google/docker/buildbot-ubuntu-clang/VERSION b/buildbot/google/docker/buildbot-ubuntu-clang/VERSION
new file mode 100644
index 0000000..c227083
--- /dev/null
+++ b/buildbot/google/docker/buildbot-ubuntu-clang/VERSION
@@ -0,0 +1 @@
+0
\ No newline at end of file
diff --git a/buildbot/google/docker/buildbot-ubuntu-clang/run.sh b/buildbot/google/docker/buildbot-ubuntu-clang/run.sh
new file mode 100755
index 0000000..e4796ff
--- /dev/null
+++ b/buildbot/google/docker/buildbot-ubuntu-clang/run.sh
@@ -0,0 +1,47 @@
+#!/bin/bash
+#===-- run.sh -------------------------------------------------------------===//
+# Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
+# See https://llvm.org/LICENSE.txt for license information.
+# SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
+#
+#===----------------------------------------------------------------------===//
+# This script will start the buildbot worker
+# 
+#===----------------------------------------------------------------------===//
+
+set -eu
+
+# Read the worker password from a mounted file.
+WORKER_PASSWORD=$(cat /vol/secrets/token)
+
+# Set up buildbot host and maintainer info.
+mkdir -p "${WORKER_NAME}/info/" 
+echo "Christian Kühnel <kuhnel@google.com>" > "${WORKER_NAME}/info/admin"
+
+# generate the host information of this worker
+( 
+  uname -a ; \
+  cat /proc/cpuinfo | grep "model name" | head -n1 | cut -d " " -f 3- ;\
+  echo "number of cores: $(nproc)" ;\
+  lsb_release -d | cut -f 2- ; \
+  clang --version | head -n1 ; \
+  ld.lld-11 --version ; \
+  cmake --version | head -n1 ; \
+) > ${WORKER_NAME}/info/host 
+
+echo "Host information:"
+cat ${WORKER_NAME}/info/host
+
+# create the folder structure
+echo "creating worker ${WORKER_NAME} at port ${BUILDBOT_PORT}..."
+buildbot-worker create-worker --keepalive=200 "${WORKER_NAME}" \
+  lab.llvm.org:${BUILDBOT_PORT} "${WORKER_NAME}" "${WORKER_PASSWORD}"
+
+# start the daemon, this command return immetiately
+echo "starting worker..."
+buildbot-worker start "${WORKER_NAME}"
+
+# To keep the container running and produce log outputs: dump the worker
+# log to stdout
+echo "Following worker log..."
+tail -f ${WORKER_NAME}/twistd.log